function UserInterfaceController(UiDiv){
	var self = this; self.name = "UserInterfaceController"; // MANDATORY

    this.stage = UiDiv;

    this.playlist_window = false;
    this.timeline_window = false;
    this.time_window = false;
    this.pause_button = null;
    
    this.volume = false; // Current Time Div
    this.active = false;
    
    this.activate = function(){
        self.active = true;
        self.stage.children("div").each(function(){
            $(this).show();
        });
        self.stage.parent().css("cursor","default");
    };
    
    this.deactivate = function(){
        self.active = false;
        self.stage.children("div").each(function(){
            $(this).hide();
        });
        self.stage.parent().css("cursor","none");
    };
    
    this.toggle = function(){
        if(self.active){
            self.deactivate();
        }else{
            self.activate();
        }
    };
    
    this.printPlaylistInfo = function(PlaylistObject,totals){     
        if(self.active){
            if(typeof(PlaylistObject) !== "undefined"){
                if(!self.playlist_window){
                    var html = '<div id="playlist-'+Date.now()+'" class="ui-playlist-window">';
                    html += '<div class="ui-playlist-window-inner">';
                    html += '';
                    html += '<div class="ui-playlist-current-pos-global"><div><div class="ui-playlist-left-arrow"></div></div>';
                    html += '<div class="ui-current-pos">-</div><div class="ui-block-pos">-</div></div>';
                    html += '<div class="ui-total-pos">-</div>';
                    html += '<div class="ui-playlist-right-arrow"></div></div></div>';
                    self.playlist_window = $(html);
                    self.stage.append(self.playlist_window);
                    self.stage.find(".ui-playlist-left-arrow").on("click",self.onClickLeft);
                    self.stage.find(".ui-playlist-right-arrow").on("click",self.onClickRight);
                }
                self.stage.find(".ui-block-pos").hide();
                if(PlaylistObject){
                    var pos = PlaylistObject.position;
                    if(pos == -1){pos = ">>";}
                    if(pos == -2){pos = "<<";}
                    self.stage.find(".ui-current-pos").html(pos);
                    if(PlaylistObject.block){
                        pos = PlaylistObject.block.pos;
                        if(pos == -1){pos = ">>";}
                        if(pos == -2){pos = "<<";}
                        self.stage.find(".ui-block-pos").html(pos);
                        self.stage.find(".ui-block-pos").show();
                        self.stage.find(".ui-current-pos").css('width','58px');
                    }else{
                        self.stage.find(".ui-current-pos").css('width','113px');
                    }
                }
                self.stage.find(".ui-total-pos").html(totals);
            }
        }       
    };
    
    this.printTimelineInfo = function(delay_next){
        if(self.active){
            if(!self.timeline_window){
                self.timeline_window = $('<div id="timeline-'+Date.now()+'" class="ui-timeline-window"><div class="ui-timeline-window-inner"><div class="ui-timeline-next">-</div></div></div>');
                self.stage.append(self.timeline_window);
            }
            self.stage.find(".ui-timeline-next").html(delay_next);
        }
    };
    
    this.loadVolume = function(){
        if(!self.volume){
            self.volume = $('<div id="volume-'+Date.now()+'" class="ui-volume-window"><div class="ui-volume-window-inner"></div></div>');  
            self.stage.append(self.volume);
        }
        self.volume.show();
    };
    
    this.secondsToHHMMSSsss = function(sec_num){
        var hours   = Math.floor(sec_num / 3600);
        var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
        var seconds = sec_num - (hours * 3600) - (minutes * 60);
        seconds = seconds.toFixed(3);
        if (hours   < 10) {hours   = "0"+hours;}
        if (minutes < 10) {minutes = "0"+minutes;}
        if (seconds < 10) {seconds = "0"+seconds;}
        
        return hours+':'+minutes+':'+seconds;
    }
    
    this.loadTime = function(currentTime,totalTime){
        if(self.active){
            currentTime = self.secondsToHHMMSSsss(currentTime);
            totalTime = self.secondsToHHMMSSsss(totalTime);
            if(!self.time_window){
                self.time_window = $('<div id="time-'+Date.now()+'" class="ui-time-window"><div class="ui-time-window-inner"><div class="ui-current-time">--:--:--.000</div>-<div class="ui-total-time">--:--:--.000</div></div></div>'); // Current Time Div
                self.stage.append(self.time_window);
            }
            self.stage.find(".ui-current-time").html(currentTime);
            self.stage.find(".ui-total-time").html(totalTime);
            self.stage.css('height','100%');
            self.time_window.show();
        }
    };
    
    this.unloadTime = function(){
        if(self.time_window){
            self.time_window.hide(); 
            self.stage.css('height','auto');
        }
    };
    
    this.unloadVolume = function(){
        if(self.volume){
            self.volume.hide();
        }
    };
    
    this.onClickLeft = function(){
        $(self).trigger("UserInterfacePlaylistPrevious");
    };

    this.onClickRight = function(){
        $(self).trigger("UserInterfacePlaylistNext");
    };

    this.unload = function(){
        if(self.playlist_window){
            self.playlist_window.remove();
            self.playlist_window = false;
        }
        if(self.timeline_window){
            self.timeline_window.remove();
            self.timeline_window = false;
        }
        if(self.time_window){
            self.time_window.remove();
            self.time_window = false;
        }
        if(self.volume){
            
        }
        self.log(" unloading UI ... ");
    };
}	
UserInterfaceController.prototype = new SystemController();
    
