var main_webos = {
    orientation : "H"
}

var player = null;
var transfer = false;
var manager = false;
var timerService = null;

var service_timer = false;

$(document).ready(function(){

    /* ENABLE DEBUG
    var configuration = new Configuration();

    var options = {};
    options.enabled = true; //enabling debug mode

    configuration.debug(function successCb() {
        console.log("Succeeded to enable the debug mode");
    },function failureCb() {
        console.log("Failed to enable the debug mode");
    },options);
    */
    initApplication();
});

function initApplication(){
  try{
    if(!player){
        player = new PlayerController();
        $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
        player.init();
    }
  }catch(e){
    $("#starter").html("System in recovery mode.");
    console.log("Unable to start player");
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;

    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp,archive);
    }catch(e){
      console.log("Unable to start transfer");
    }
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      manager.activateLogger(player.debug);
      manager.update(schedule);
    }catch(e){
      console.log("Unable to start manager");
    }
  }
}

function onPlayerDataLoaded(){
  $("#starter").hide();
  setTimeout(function(){
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;
    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp,archive);
    }catch(e){
      console.log("Unable to start transfer");
    }
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
          try{
            transfer.onUpdatedManagerInterval = function(interval){
              console.log("Checking ManagerService Interval");
              manager.checkInterval(interval);
            };
          }catch(e){
            console.log("Could not check interval for management");
          }
      }
      manager.activateLogger(player.debug);
      manager.update(schedule);
    }catch(e){
      console.log("Unable to start manager");
    }
    setTimeout(function(){transfer.OS.insertTimersOrReboot(player.config.getForceReboot24h());}, 10000);
    transfer.OS.clearCache();
    setInterval(function(){transfer.OS.clearCache();}, 7200000);
    var custom = new Custom();
    custom.Signage.getwebOSVersion(
      function successCallback(successObject) {
        if(successObject.webOSVersion != "6.0"){
          transfer.OS.setPictureProperty();
          setInterval(function(){transfer.OS.setPictureProperty();}, 7200000);
        }
      },
      function failureCallback(failureObject){
        transfer.OS.setPictureProperty();
        setInterval(function(){transfer.OS.setPictureProperty();}, 7200000);
      }
    )
    if(!timerService){
        timerService = new TimerService();
    }
    timerService.checkTimers(schedule);
    if(!service_timer){
  			service_timer = setInterval(service,10000);
  	}
  }, 5000);
}

function service(){
	if(player){
		player.service();
		try{
			if(transfer){
					transfer.updateInfo(player.name,player.getInfo());
			}
		}catch(e){
			console.log("Unable to update player info for transfer");
		}
	}
}




$(document).on("keydown",function(event){
    var keyCode = event.keyCode;
    player.log("WebOS Keydown : "+keyCode);

    switch (keyCode) {
        case 37:
            player.playlist.jump(-1);
            break;
        case 39:
            player.playlist.jump();
            break;
        case 49:
            player.toggleCoreSetupWindow();
            break;
        case 50:
            player.toggleProxySetupWindow();
            break;
        case 48:
            player.debug = !player.debug;
            try{
              player.setLogger($("#playerLog"));
              player.activateLogger(player.debug);
            }catch(e){
              console.log("Error on player toggle debug");
            }
            try{
              transfer.setLogger($("#transferLog"));
              transfer.activateLogger(player.debug);
              manager.setLogger($("#transferLog"));
            }catch(e){
              console.log("Error on transfer toggle debug");
            }
            break;
        case 406:
            try{
              player.OS.upgradeApplicationNow();
            }catch(e){
              console.log("Error on player App update");
              try{
                transfer.OS.upgradeApplicationNow();
              }catch(e){
                  console.log("Error on transfer App update");
              }
            }
            break;
        default:
            player.log("TV : Unhandled key");
            break;
    }
});
