function TransferService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "TransferService"; // MANDATORY

    this.license = new RegisterService();
    this.file_manager = false;
    this.analytic = false;

    this.xml_timestamp = 0;
    this.day_xml_timestamp = 0;

    this.screenshot = false;
    this.no_screenShot = false;

    this.hardware_info = "";
    this.bundle = "0";
    this.pass = 0;

    this.alive_interval = 20000;
    this.live_interval = 20000;
    this.library_interval = 12000;
    this.errors_interval = 60000;
    this.management_interval = 20000;
    this.screens_check_interval = 20000;
    this.screens_status_interval = 20000;
    this.screens_commands_interval = 10000;
    this.prefered_recheck_interval = 300000; // 1min
    this.last_prefered_success_timestamp = 0;

    this.alive_timer = 0;
    this.library_timer = 0;
    this.live_timer = 0;
    this.errors_timer = 0;

    this.timeChecked = false;
    this.timeCheckRetries = 0;

    this.initiated = false;
    //this.started = false;

    this.setTimeCallback = false;

    this.player_version = "";

    this.reading_errors = false;
    this.sendTimers = false;

    this.info = {};

    this.getAliveData = [];
    this.getAliveResponseData = [];
    this.checkAliveServers = [];
    this.onNewScreenshot = [];
    this.sendLibraryData = [];
    this.checkIntervals = [];

    this.is_multiplayer = false;

    this.uses_proxy = false;

    this.connection_errors_count = 0;

    this.init = function(player_version,force_platform){
        //var test = this.isgoingtofail(); //<-- MAKE PLAYER FAIL !! TEST !!!
        self.player_version = player_version;
        try{
          self.version = self.version+" {"+process.versions.nw+"}"
        }catch(e){
          self.log("Not NWJS");
        }
        if(!self.initiated){
            self.initiated = true;
            self.setPlatform(force_platform);
            self.OS.init(self.start);
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Warning ... Transfer already initated ¿? ... set started = true");
            self.started = true;
        }
    };

    this.start = function(){
        self.OS.readFile(self.ROUTES['CORE'].path,self.initialCore);
        self.checkProxyConfig();
        try{
					self.OS.SocketConnector.setWhoAmI(self.name);
				}catch(e){
					console.log(e);
				}
    };

    this.checkProxyConfig = function(){
      if(!self.uses_proxy){
        self.OS.readFile(self.ROUTES['PROXY_CONF'].path,function(data){
            var reverse_proxy_conf = false;
            try{
              if(data !== ""){
              reverse_proxy_conf = JSON.parse(data);
              try{
                // WAIT FOR SOC SYSTEM SERVICES TO START (NodeJS for WebOS / Tizen)
                if(reverse_proxy_conf.cert_file !== ""){
                  self.OS.readFile(reverse_proxy_conf.cert_file,function(data){
                    reverse_proxy_conf.cert_data = data;
                    setTimeout(function(){
                      self.OS.setReverseProxyConfig(reverse_proxy_conf,function(ok){
                        self.uses_proxy = ok;
                      });
                    },5000);
                  });
                }else{
                  setTimeout(function(){
                    self.OS.setReverseProxyConfig(reverse_proxy_conf,function(ok){
                      self.uses_proxy = ok;
                    });
                  },5000);
                }
              }catch(e){
                console.log("NOT USING REVERSE PROXY ---- Maybe platform does not support this feature ...  ");
                console.log(e);
              }
              self.api_connector.setProxyOptions(reverse_proxy_conf);
              self.OS.api_connector.setProxyOptions(reverse_proxy_conf);
              self.OS.setProxyConfig(reverse_proxy_conf);
              self.log("USING PROXY ! ");
          }else{
            self.log("NOT USING PROXY ---- No Proxy Config found : ");
          }
          }catch(e){
            self.log("NOT USING PROXY ---- No Valid Proxy Config found : ");
            self.log(data);
          }
        });
      }
    };

    this.updateInfo = function(name,data){
      self.info[name] = null;
      self.info[name] = data;
    };

    this.initialCore = function(data){
        self.started = true;
        if(data !==  ""){
            self.setAPIroutes(data);
            self.license.project_id = self.autoregister;
            self.ROUTES['CORE'].exists = true;
            if(self.platform == "SOC" || self.platform == "WEBOS"){
                self.log("No need for config file");
            }else{
                self.OS.readFile(self.ROUTES['CONFIG'].path,self.initialConfig);
            }
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function initialCore()  :  started: "+self.started);
        }
    };

    this.initialConfig = function(data){
        if(data !==  ""){
            self.setPaths(data);
            self.started = true;
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function initialConfig()  :  started: "+self.started);
        }
        var api_server_list = {
                id: "api_server_list",
                player:0,
                name: self.name
            };
        self.getStatusFile(api_server_list,function(data,params){
            var has_list = false;
            if(typeof(data) !== "undefined"){
                if(typeof(data.list) !== "undefined"){
                    self.updateApiServerList(data.list);
                    has_list = true;
                    console.log("Setting new list api_url and api_server_url");
                    var next_api_server_from_list = self.getNextApiServer();
                    self.setApiUrl(next_api_server_from_list);
                    self.setApiServerUrl(next_api_server_from_list);
                }
            }
            if(!has_list){
              self.updateApiServerList([""+self.api_url+""]);
            }
        });
    };


    this.update = function(timestamp){
        if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC"){
            self.timeChecked = true;
        }else{
            self.timeChecked = false;
        }
        self.day_xml_timestamp = timestamp;

        if(!self.file_manager){
          self.file_manager = new FileManagerService();
          $(self.file_manager).on("FileManagerFree",self.onFileManagerFree);
        }
        if(self.platform != "ONLINE"){
          self.file_manager.update();
        }

        setTimeout(function(){self.OS.getInfoSystem();},5000);

        if(!self.alive_timer){
            self.alive();
        }
        if(self.platform != "ONLINE"){
          if(!self.library_timer){
              self.library();
          }
          if(!self.errors_timer){
              self.check_errors();
          }
          if(!self.live_timer){
              self.live();
          }
        }

        if(!self.analytic){
            self.analytic = new StatisticService();
            self.analytic.init();
        }
    };

    this.alive = function(){
        clearTimeout(self.alive_timer);
        if(!self.OS.busy){
          self.internet_connected = self.OS.internetConnected();
          if(self.platform != "SOC"){
            self.internet_connected = true;
          }
          if(self.internet_connected && self.started){
              self.log("# Alive beat ... ");
              if(!self.license.registered){
                  self.license.register(self.onRegisterComplete);
              }else{
                  // Send Alive
                  if(self.platform != "SOC"){
                      if(self.bundle == "0"){
                          self.OS.readFile(self.ROUTES['VER'].path,function(data,file_ref,params){
                        	  self.log("bundle------------------------------------------------------------- "+data);
                              if(data != "" && self.bundle != data){
                                  self.bundle = data;
                              }
                          });
                      }
                  }
                  var data = self.getAliveData[self.api_ver]();
                  self.log(data);
                  self.log("Sending alive for player : "+self.core_id+" Using protocol : "+self.api_connector.protocol);
                  self.api_connector.post(self.api_url,self.api_ver,"player/alive",data,self.aliveResponse);

                  if(!self.timeChecked){
                    self.api_connector.get(self.api_url,self.api_ver,"player/timezone/id",self.core_id,self.serverDateTimeResponse);
                  }

                  self.OS.findSyncIp(function(info){
                      if(typeof(info.ip) !== "undefined"){
                          self.local_ip = info.ip;
                      }
                  });
              }
          }else{
              self.log("# Alive beat ... started: "+self.started+" internet : "+self.internet_connected);
          }
          self.alive_timer = setTimeout(self.alive,self.alive_interval);
        }else{
          self.alive_timer = setTimeout(self.alive,5000);
          self.log("# Alive beat ... CANCELED ... OS is busy");
        }
        self.checkProxyConfig();
    };

    this.onRegisterComplete = function(){
      //self.alive();
    };

    this.getAliveResponseData["2.0"] = function(response){
        var data = {
          update_xml_day: false,
          update_xml_week: false,
          xml_day_tstamp : self.day_xml_timestamp,
          xml_week_tstamp : self.xml_timestamp,
          live_interval: self.live_interval,
          no_screenshot : self.no_screenShot
        };
        try{
          var JQUERY = null;
          if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC"){
            JQUERY = jQuery;
          }else{
            JQUERY = $;
          }
          var xml_response = JQUERY.parseXML(response);
          if(JQUERY(xml_response).find("playlist").length > 0){
            data.update_xml_day = Boolean(JQUERY(xml_response).find("playlist")[0].innerHTML);
          }
          self.log("Day XML Check : Needs Update : "+data.update_xml_day);
          if(JQUERY(xml_response).find("playlist_week").length > 0){
            data.update_xml_week = Boolean(JQUERY(xml_response).find("playlist_week")[0].innerHTML);
          }
          self.log("Week XML Check : Needs Update : "+data.update_xml_week);
          if(JQUERY(xml_response).find("live_interval").length > 0){
            data.live_interval = parseInt(JQUERY(xml_response).find("live_interval")[0].innerHTML);
          }
          if(JQUERY(xml_response).find("no_screenShot").length > 0){
            data.no_screenshot = JQUERY(xml_response).find("no_screenShot")[0].innerHTML;
            if(data.no_screenshot === "true"){
               data.no_screenshot = true;
            }else{
                data.no_screenshot = false;
            }
          }
        }catch(e){
          console.log("Exception on getAliveResponseData 2.0 ");
        }
        return data;
    };

    this.getAliveResponseData["3.0"] = this.getAliveResponseData["4.0"] = function(response){
        var data = {
          update_xml_day: false,
          update_xml_week: false,
          xml_day_tstamp : 0,
          xml_week_tstamp : 0,
          live_interval: self.live_interval,
          no_screenshot : self.no_screenShot
        };
        try{
          if(typeof(response.week) !== "undefined"){
              data.xml_week_tstamp = parseFloat(""+response.week);
          }else if(typeof(response.xml_week) !== "undefined"){
              data.xml_week_tstamp = parseFloat(""+response.xml_week);
          }
          if(self.xml_timestamp != parseFloat(data.xml_week_tstamp)){
            data.update_xml_week = true;
          }
          self.log("Week XML Check : Local : "+self.xml_timestamp+" --- Remote : "+data.xml_week_tstamp+" Needs Update : "+data.update_xml_week);
          if(typeof(response.day) !== "undefined"){
              data.xml_day_tstamp = parseFloat(""+response.day);
          }else if(typeof(response.xml_day) !== "undefined"){
              data.xml_day_tstamp = parseFloat(""+response.xml_day);
          }
          if(self.day_xml_timestamp != data.xml_day_tstamp){
              data.update_xml_day = true;
          }
          if(data.update_xml_day){
            if(data.xml_day_tstamp <= data.xml_week_tstamp){
              data.update_xml_day = false;
            }
          }
          self.log("Day XML Check : Local : "+self.day_xml_timestamp+" --- Remote : "+data.xml_day_tstamp+" Needs Update : "+data.update_xml_day);
          try{
            if(typeof(response.live_interval) !== "undefined"){
              data.live_interval = parseInt(response.live_interval);
            }
          }catch(ex){
            console.log("Exception on getAliveResponseData 3.0 Bad Live Interval");
          }
          try{
            if(typeof(response.no_screenShot) !== "undefined"){
              data.no_screenshot = response.no_screenShot;
            }
          }catch(ex){
            console.log("Exception on getAliveResponseData 3.0 Bad No Screenshot");
          }
        }catch(e){
          console.log("Exception on getAliveResponseData 3.0 ");
        }

        return data;
    };

    this.aliveResponse = function(response,status,params){
        if(status == "success"){
            try{
                var timestamp = self.xml_timestamp;
                if(self.xml_timestamp == 0){
                  timestamp = parseInt(self.getDate().getTime()/1000);
                }
                if(self.platform !== "ONLINE"){
                  var response_data = self.getAliveResponseData[self.api_ver](response);
                  if(response_data.update_xml_week){
                      self.log("XML Check : Pending download Week XML");
                      if(!self.file_manager.downloading){
                          self.file_manager.downloadDataXML(response_data.xml_week_tstamp,self.onPlaylistDownloaded,self.onPlaylistDownloadedError);
                      }else{
                          self.file_manager.checkDataXML(response_data.xml_week_tstamp,self.onPlaylistDownloaded);
                      }
                  }else if(response_data.update_xml_day && !self.is_multiplayer){

                      self.log("XML Check : Pending download Day XML");
                      if(!self.file_manager.downloading){
                          self.file_manager.downloadDataDayXML(response_data.xml_day_tstamp,self.onPlaylistDayDownloaded,self.onPlaylistDayDownloadedError);
                      }else{
                          // TODO : Do we need to check Day XML zip ¿?
                          //self.file_manager.checkDataXML(newDayTstamp,self.onPlaylistDownloaded);
                      }

                  }
                  self.setLiveInterval(response_data);
                  self.checkAliveServers[self.api_ver](response);
                  self.checkIntervals[self.api_ver](response);
                }
            }catch(e){
                self.log("Error reading Alive response : " + e);
                self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Function aliveResponse() failed : Error reading Alive response ... ");
                self.log(response);
            }
        }else{
          if(self.connection_errors_count >= 5){
            self.connection_errors_count = 0;
            self.uses_proxy = false;
            self.checkProxyConfig();
          }else{
            self.connection_errors_count++;
          }
          self.notifyError(self.ERROR['TRANSFER_SERVICE']+15,self.name+": Function aliveResponse() failed : request status not success = "+status);
        }
    };

    this.setLiveInterval = function(response_data){
      try{
        if(self.no_screenShot != response_data.no_screenshot){
            if(response_data.no_screenshot == true){
                self.log("TurnOn no_screenShot.");
                self.live_interval = 86400000;
                clearTimeout(self.live_timer);
                self.live_timer = null;
                self.no_screenShot = true;
                self.OS.superEco = true;
                self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Changing live interval to  : 86400000 and supereco = true");
            }else{
                self.OS.superEco = false;
                self.no_screenShot = false;
                if(response_data.live_interval != self.live_interval && response_data.live_interval > 20000){
                    self.log("Changing live interval to  : "+response_data.live_interval+" and eco = true");
                    self.OS.eco = true;
                    self.live_interval = parseInt(response_data.live_interval);
                    clearTimeout(self.live_timer);
                    self.live_timer = setTimeout(self.live,self.live_interval);
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Changing live interval to  : "+response_data.live_interval+" and eco = true and supereco = false");
                }else{
                    self.log("Changing live interval to  : "+response_data.live_interval+" and eco = false");
                    self.OS.eco = false;
                    self.live_interval = response_data.live_interval;
                    clearTimeout(self.live_timer);
                    self.live_timer = setTimeout(self.live,response_data.live_interval);
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Changing live interval to  : "+response_data.live_interval+" and eco = false and supereco = false");
                }
            }
        }else{
            if(response_data.live_interval != self.live_interval && response_data.live_interval > 20000){
                self.log("Changing live interval to  : "+response_data.live_interval+" and eco = true");
                self.OS.eco = true;
                self.live_interval = parseInt(response_data.live_interval);
                clearTimeout(self.live_timer);
                self.live_timer = setTimeout(self.live,self.live_interval);
                self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Changing live interval to  : "+response_data.live_interval+" and eco = true");
            }else{
                if(response_data.live_interval != self.live_interval){
                    self.log("Changing live interval to  : "+response_data.live_interval+" and eco = false");
                    self.OS.eco = false;
                    self.live_interval = parseInt(response_data.live_interval);
                    clearTimeout(self.live_timer);
                    self.live_timer = setTimeout(self.live,self.live_interval);
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Changing live interval to  : "+response_data.live_interval+" and eco = false");
                }
            }
        }
        if(self.OS.eco == true || self.OS.superEco == true){
            self.intervalManagement = 120000;
        }else{
            self.intervalManagement = 20000;
        }
      }catch(e){
          self.log("Exception on setLiveInterval");
      }
    }

    this.checkIntervals["2.0"] = function(response){
      // NOT IMPLEMENTED IN 2.0 // AVOID
    };

    this.checkIntervals["3.0"] = this.checkIntervals["4.0"] = function(response){
      if(typeof(response.managementIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.managementIntervalConfig)) && response.managementIntervalConfig !== self.management_interval && response.managementIntervalConfig){
          self.management_interval = response.managementIntervalConfig;
          self.onUpdatedManagerInterval(self.management_interval);
        }
      }

      if(typeof(response.aliveIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.aliveIntervalConfig)) && response.aliveIntervalConfig !== self.alive_interval && response.aliveIntervalConfig < 60000){
          self.alive_interval = response.aliveIntervalConfig;
          clearTimeout(self.alive_timer);
          self.alive_timer = setTimeout(self.alive,self.alive_interval);
        }
      }

      if(typeof(response.errorsIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.errorsIntervalConfig)) && response.errorsIntervalConfig !== self.errors_interval){
          self.errors_interval = response.errorsIntervalConfig;
          clearTimeout(self.errors_timer);
          self.errors_timer = setTimeout(self.check_errors,self.errors_interval);
        }
      }

      if(typeof(response.libraryIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.libraryIntervalConfig)) && response.libraryIntervalConfig !== self.library_interval){
          self.library_interval = response.libraryIntervalConfig;
          clearTimeout(self.library_timer);
          self.library_timer = setTimeout(self.library,self.library_interval);
        }
      }

      if(typeof(response.preferedIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.preferedIntervalConfig)) && response.preferedIntervalConfig !== self.prefered_recheck_interval){
          self.prefered_recheck_interval = response.preferedIntervalConfig;
        }
      }

      var screens_intervals_changed = false;
      if(typeof(response.checkScreensIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.checkScreensIntervalConfig)) && response.checkScreensIntervalConfig !== self.screens_check_interval && response.checkScreensIntervalConfig){
          self.screens_check_interval = response.checkScreensIntervalConfig;
          screens_intervals_changed = true;
        }
      }

      if(typeof(response.screenStatusIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.screenStatusIntervalConfig)) && response.screenStatusIntervalConfig !== self.screens_status_interval && response.screenStatusIntervalConfig){
          self.screens_status_interval = response.screenStatusIntervalConfig;
          screens_intervals_changed = true;
        }
      }

      if(typeof(response.screenCommandsIntervalConfig) !== "undefined"){
        if(!isNaN(parseInt(response.screenCommandsIntervalConfig)) && response.screenCommandsIntervalConfig !== self.screens_commands_interval && response.screenCommandsIntervalConfig){
          self.screens_commands_interval = response.screenCommandsIntervalConfig;
          screens_intervals_changed = true;
        }
      }

      if(screens_intervals_changed){
        self.onUpdatedScreensInterval({
            checkScreens : self.screens_check_interval,
            screenStatus : self.screens_status_interval,
            screenCommands : self.screens_commands_interval
        });
      }

      if(typeof(response.registerIntervalConfig) !== "undefined"){
        // TODO : Actually in this.check_errors function ... decide if we move it to ALIVE or we create another timer
      }
    };

    this.onUpdatedManagerInterval = function(interval){
      // OVERRIDE Function for ManagerService
    };

    this.onUpdatedScreensInterval = function(intervals){
      // OVERRIDE Function for ScreenService
    };



    this.checkAliveServers["2.0"] = function(response){
      // NOT IMPLEMENTED IN 2.0 // AVOID
    };

    this.checkAliveServers["3.0"] = this.checkAliveServers["4.0"] = function(response){
      self.api_server_index = 0;
      var has_list = false;
      if(typeof(response.api_server_list) !== "undefined"){
        has_list = true;
        self.updateApiServerList(response.api_server_list);
        var api_server_list = {
            id: "api_server_list",
            player:0,
            name: self.name,
            list : response.api_server_list
        };
        self.saveStatusFile(api_server_list);
      }

      if(Date.now() - self.last_prefered_success_timestamp > self.prefered_recheck_interval){
        self.last_prefered_success_timestamp = Date.now();
        var save_core_file = false;
        if(typeof(response.api_server_prefered) !== "undefined"){
          if(typeof(response.api_server_prefered.api_url) !== "undefined"){
            if(self.api_url != response.api_server_prefered.api_url){
              self.setApiUrl(response.api_server_prefered.api_url);
              if(!has_list){
                self.updateApiServerList([""+response.api_server_prefered.api_url+""]);
              }
              save_core_file = true;
            }
          }
          if(typeof(response.api_server_prefered.api_server_url) !== "undefined"){
            if(self.api_server_url != response.api_server_prefered.api_server_url){
              self.setApiServerUrl(response.api_server_prefered.api_server_url);
              save_core_file = true;
            }
          }
          if(typeof(response.api_server_prefered.api_server_version) !== "undefined"){
            if(self.api_server_version != response.api_server_prefered.api_server_version){
              self.setApiVer(response.api_server_prefered.api_server_version);
              save_core_file = true;
            }
          }
          if(save_core_file){
            self.license.saveCoreFile();
          }
          if(typeof(response.api_server_prefered.iot_url) !== "undefined"){
            if(self.iot_url != response.api_server_prefered.iot_url){
              self.setIOTServerUrl(response.api_server_prefered.iot_url);
            }
          }
        }
      }
    };

    this.getAliveData["2.0"] = function(){
      var status = 1;
      var data = "id="+self.OS.core_id;
      data +="&status="+status;
      data +="&token="+self.OS.api_key;
      data +="&pase="+self.pass;
      data +="&video_id="+self.OS.id_content_now;
      data +="&datetime="+parseInt(self.getDate().getTime()/1000);
      data +="&bundle="+self.bundle;
      data +="&vplayer="+self.player_version;
      data +="&xml_day="+self.day_xml_timestamp;
      data +="&xml_week="+self.xml_timestamp;
      data +="&xml_timestamp="+self.xml_timestamp;
      data +="&api_key="+self.OS.api_key;
      data +="&uptime=0";
      data +="&local_ip=0.0.0.0";
      return data;
    };

    this.getAliveData["3.0"] = this.getAliveData["4.0"] = function(){
        var playlist_status = {
                id: "status",
                player:self.core_id,
                name: "PlaylistController"
            };
        self.getStatusFile(playlist_status,function(data,params){
            if(typeof(data) !== "undefined"){
                if(typeof(data.pass) !== "undefined"){
                    if(!isNaN(data.pass)){
                        self.pass = data.pass;
                    }
                }
            }
        });


        try{
          self.updateInfo("OperatingSystem",self.OS.getInfo(!self.OS.sendInfoSystem));
          if(self.OS.dataInfoSystem != null && self.OS.sendInfoSystem == false){
              self.OS.sendInfoSystem = true;
          }
        }catch(e){
          self.log("Could not get Operating System Info");
        }

        var data = {
            id: self.core_id,
            status: 1,
            content_id : self.OS.id_content_now,
            xml_day: self.day_xml_timestamp,
            xml_timestamp: self.xml_timestamp,
            xml_week: self.xml_timestamp,
            system: self.platform,
            vtransfer: self.version,
            vplayer: self.player_version,
            bundle: self.bundle+" - "+self.version_name,
            pase: self.pass,
            protocol: self.api_connector.protocol,
            info: self.info
        }


        self.log(JSON.stringify(data));
        if(self.no_screenShot == true){
            if(self.OS.screenshotServer != null){
                data.sc = self.OS.screenshotServer;
                self.OS.screenshotServer = null;
            }
            else{
                data.sc = "";
            }
        }
        else{
            data.sc = self.screenshot;
            self.screenshot = "";
        }
        return data;
    };

    this.onFileManagerFree = function(e,all_downloaded,notify){
      if(typeof(all_downloaded) === "undefined"){all_downloaded = false;}
      if(typeof(notify) === "undefined"){notify = false;}
      self.log("FileManager : Free .... All downloaded ? "+all_downloaded);
      if(!all_downloaded){
        self.log("Force Continue Library");
        self.library(notify);
      }
    };

    this.onPlaylistDownloaded = function(ok,params){
        if(ok){
            self.OS.readFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,function(data,file_ref,params){
              if(data !== ""){
                self.xml_timestamp = parseFloat(data);
                self.log("onPlaylistDownloaded : XML Week Download : ok with tstamp = "+self.xml_timestamp);
              }else{
                self.log("XML Check : Problem no XML WEEK TIMESTAMP found.");
              }
            });
        }else{
            self.log("XML Check : Problem downloading or unzipping playlist data : ");
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDownloaded() failed : Problem downloading or unzipping playlist data file ");
        }
    };

    this.onPlaylistDownloadedError = function(error,params){
        self.log("XML Check : Problem downloading or unzipping playlist data : ");
        self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDownloadedError() failed : Problem downloading or unzipping playlist data file ");
        self.log(error);
    };

    this.onPlaylistDayDownloaded = function(ok,params){
        if(ok){
            self.log("onPlaylistDayDownloaded : XML Day Download : ok ");
        }else{
            self.log("onPlaylistDayDownloaded : XML Check :  Problem downloading or unzipping playlist data file from XML Day ");
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDayDownloaded() failed : Problem downloading or unzipping playlist data file from XML Day ");
        }
    };

    this.onPlaylistDayDownloadedError = function(error,params){
        self.log("onPlaylistDayDownloadedError: XML Check : Problem downloading or unzipping playlist data file from XML Day ");
        self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDayDownloadedError() failed : Problem downloading or unzipping playlist data file from XML Day ");
        self.log(error);
    };


    this.library = function(notify){
        if(typeof(notify) === "undefined"){notify = true;}
        clearTimeout(self.library_timer)
        self.library_timer = setTimeout(self.library,self.library_interval);
        if(self.internet_connected && self.started && !self.OS.busy){
            //self.notifyError(self.ERROR['TRANSFER_SERVICE']+5,self.name+": Function library() : internet connection OK ");
            self.log("# Library beat ... "+self.file_manager.library.length);
            var internet_is_really_available = self.OS.internetConnected();
            if(internet_is_really_available){
              self.log("Real Internet Connection Found - Downloading pending files ...");
              self.file_manager.downloadPendingFilesInArchive();
            }else{
              self.log("NO Real Internet Connection Found - Avoiding downloading files");
            }
            if(notify){
              if(self.file_manager.library.length != self.file_manager.lastLibraryCount && self.file_manager.initiated){
                  self.log("# Notifing Library Changes ...");
                  self.sendLibraryData[self.api_ver](self.file_manager.library);
              }else{
                  self.log("# No Changes on Library.");
              }
            }
        }else{
            self.log("# Library beat ...  started: "+self.started+" internet : "+self.internet_connected);
            //self.notifyError(self.ERROR['TRANSFER_SERVICE']+6,self.name+": Function library() :  started: "+self.started+" internet : "+self.internet_connected);
        }
    };

    this.sendLibraryData["2.0"] = function(lib){
      var data = "&id="+self.core_id;
      for(var i=0;i<lib.length;i++){
        data += "&videos="+lib[i];
      }
      self.api_connector.post(self.api_url,self.api_ver,"player/library",data,self.libraryResponse,self.file_manager.library.length);
    };

    this.sendLibraryData["3.0"] = this.sendLibraryData["4.0"] = function(lib){
      var data = {
          id: self.core_id,
          videos : lib
      }
      self.api_connector.post(self.api_url,self.api_ver,"player/library",data,self.libraryResponse,self.file_manager.library.length);
    };

    this.libraryResponse = function(response,status,params){
        if(status == "success"){
            self.file_manager.lastLibraryCount = params;
        }
        self.log("Library response status : "+status+" | "+response);
    };

    this.check_errors = function(){
        self.license.checkApiKey();
        clearTimeout(self.errors_timer);
        if(self.platform != "ONLINE"){
          self.errors_timer = setTimeout(self.check_errors,self.errors_interval);
          if(self.license.registered && !self.OS.busy){
              if(!self.reading_errors){
                  self.reading_errors = true;
                  self.log("Check log/errors ... read directory");
                  try{
                      self.OS.readDirectory(self.ROUTES['LOG'].path,self.errorsList);
                  }
                  catch(e){
                      self.log(e)
                      self.reading_errors = false;
                  }

              }
          }
        }
    };

    this.errorsList = function(files){
        if(typeof(files) !== "undefined"){
            var errorFiles = [];
            var check_file = null;
            var check_file_extension = null;
            for(var i=0;i<files.length;i++){
                check_file = null;
                check_file = files[i];
                if(typeof(check_file) !== "undefined"){
                    if(check_file != ""){
                        if(self.platform == "SOC"){
                            check_file = check_file.substring(2,check_file.length-1);
                        }
                        check_file_extension = null;
                        check_file_extension = check_file.substring(check_file.lastIndexOf('.'),check_file.length);
                        if(check_file_extension == ".err"){
                            errorFiles.push(check_file);
                        }
                    }
                }
            }

            if(errorFiles.length > 0){
                var error_file = errorFiles[errorFiles.length-1];
                if(typeof(error_file) !== "undefined"){
                    if(error_file != ""){
                        var extension = error_file.substring(error_file.lastIndexOf('.'),error_file.length);
                        if(extension == ".err"){
                            self.log("Check log/errors ... reading file : "+error_file);
                            self.OS.checkSize(self.ROUTES['LOG'].path+error_file, function(deleteFile){
                                if(deleteFile){
                                    self.OS.deleteFile(self.ROUTES['LOG'].path+error_file);
                                    self.reading_errors = false;
                                }
                                else{
                                    self.OS.readFile(self.ROUTES['LOG'].path+error_file,function(data,file_ref,params){
                                        var dataJSON = {};
                                        try{
                                            dataJSON = JSON.parse(data);
                                            var timestamp = parseInt(self.getDate().getTime()/1000);
                                            var post_data = "id="+self.core_id+"&tstamp="+timestamp+"&error=0&message="+JSON.stringify(dataJSON);
                                            self.api_connector.post(self.api_url,self.api_ver,"player/errors",post_data,self.errorsResponse,{filename:""+error_file});
                                        }catch(e){
                                            self.log("Problem reading error data ... avoid : "+e.message);
                                            self.OS.deleteFile(self.ROUTES['LOG'].path+error_file);
                                            self.reading_errors = false;
                                        }
                                    });
                                }
                            })

                        }else{
                            self.log("Check log/errors ... bad extension : "+error_file);
                            self.reading_errors = false;
                        }
                    }else{
                        self.log("Check log/errors ... no valid file: ");
                        self.reading_errors = false;
                    }
                }else{
                    self.log("Check log/errors ... could not read dir");
                    self.reading_errors = false;
                }
            }else{
                self.log("Check log/errors ... dir is empty");
                self.reading_errors = false;
            }
            errorFiles = null;
        }
    };

    this.errorsResponse = function(response,status,params){
        self.log("Send system errors response with status : "+status+" and response : "+response);
        self.OS.deleteFile(self.ROUTES['LOG'].path+params["filename"],function(ok,filename,params){
            self.reading_errors = false;
            if(ok){
                self.OS.readDirectory(self.ROUTES['LOG'].path,self.errorsList);
            }
        });
    };

    this.live = function(){
        if(self.no_screenShot == false || self.no_screenShot == "false"){
            if(self.live_interval != null && self.live_interval != "null"){
                self.log("# Live beat ... with interval : "+self.live_interval);
                clearTimeout(self.live_timer);
                self.live_timer = setTimeout(self.live,self.live_interval);
                if(!self.OS.busy){
                    if(self.OS.eco == true){
                        self.OS.takeScreenshot(self.onNewScreenshot[self.api_ver], 0.2);
                    }
                    else{
                        self.OS.takeScreenshot(self.onNewScreenshot[self.api_ver]);
                    }
                }
            }
            else{
                self.log("# Live not beat ... no_screenShot is "+self.no_screenShot+ "  and live_interval is "+ self.live_interval);
                clearTimeout(self.live_timer);
            }
        }
        else{
            self.log("# Live not beat ... no_screenShot is "+self.no_screenShot);
            clearTimeout(self.live_timer);
        }
    };

    this.onNewScreenshot["3.0"] = this.onNewScreenshot["4.0"] = function(base64Image,params){
        self.log("Screenshot created ... ready to send.");
        self.screenshot = base64Image;
    };

    this.onNewScreenshot["2.0"] = function(base64Image,params){
      try{
        var dataURI = "data:image/jpeg;base64,"+base64Image;
        var byteString;
        if (dataURI.split(',')[0].indexOf('base64') >= 0){
          byteString = atob(dataURI.split(',')[1]);
        }else{
          byteString = unescape(dataURI.split(',')[1]);
        }
        // separate out the mime component
        var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
        // write the bytes of the string to a typed array
        var ia = new Uint8Array(byteString.length);
        for(var i=0;i<byteString.length;i++){
          ia[i] = byteString.charCodeAt(i);
        }
        blob = new Blob([ia], {type: mimeString});
        var data = new FormData();
        data.append('file', blob, 'blob.jpg');
        self.api_connector.post(self.api_url,self.api_ver,"player/screenshot/id/"+self.core_id,data);
      }catch(e){
        console.log("Exception : upload_screenshot failed !!");
      }
    };

    this.serverDateTimeResponse = function(response,status){
        if(status == "success"){
            var bad_date = false;

            var data = ""+response;
            var data_array = data.split(":");
            var localDate = parseInt(new Date().getTime()/1000);
            if(self.platform == "SOC"){
                var time_api = document.getElementById('timePlugin');
                time_api.Open('Time', '1.000', 'Time');
                var soc_timestamp = time_api.Execute('GetEpochTime');
                time_api.Close();
                time_api = null;
                localDate = parseInt(soc_timestamp);
            }
            self.log("Localtime : ["+localDate+"]");
            var serverDate = parseInt(data_array[0]);
            self.log("Servertime : ["+serverDate+"]");
            var timezoneOffset = parseInt(data_array[1]);
            self.log("TimezoneOffset : ["+timezoneOffset+"]");
            var offset = localDate - serverDate;
            self.log("Local offset : ["+offset+"]");
            var new_timestamp = parseInt(localDate+(offset*-1)+(timezoneOffset*-1));
            self.log("New timestamp : ["+new_timestamp+"]");
            var futureTimezoneChange = parseInt(data_array[2]);
            var futureTimezoneOffset = parseInt(data_array[3]);

            // 48h = 172800 secs // check invalid datetimes.
            self.log(localDate+" > "+(serverDate - 172800)+" || "+localDate+" < "+(serverDate + 172800));

            if(localDate > (serverDate - 172800) && localDate < (serverDate + 172800)){
                self.log("Time is GOOD !");
                self.timeCheckRetries = 0;
                self.timeChecked = true;
            }else{
                self.log("Not good datetime yet with retries : "+self.timeCheckRetries);
                self.timeChecked = false;
                if(self.timeCheckRetries > 5){
                    if(self.platform == "SOC"){
                        self.OS.readFile(self.ROUTES['REBOOT'].path,function(value,file_ref,params){
                            if(value != ""){
                                try{
                                    if(value.length > 0){
                                        var reboots = parseInt(value);
                                        if(reboots < 5){
                                            self.OS.writeFile(self.ROUTES['REBOOT'].path,(reboots+1),function(ok,file_ref,params){
                                                self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                                setTimeout(function(){
                                                    self.OS.rebootSystem(self.platform);
                                                }, 10000);
                                            });
                                        }
                                        else{
                                            var ob='<img  width="1920" height="1080" src="'+self.ROUTES['STYLE'].path+'"contactTechnicalSupport.jpg">';
                                            document.getElementById("emergency").innerHTML=ob;
                                        }
                                    }
                                    else{
                                        self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                            setTimeout(function(){
                                                self.OS.rebootSystem(self.platform);
                                            }, 10000);
                                        });
                                    }
                                }catch(e){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Reboot required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                }
                            }
                            else{
                                self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                });
                            }
                        });
                    }
                }else{
                    self.timeCheckRetries++;
                    if(self.platform == "SOC"){
                        self.OS.readFile(self.ROUTES['REBOOT'].path,function(value,file_ref,params){
                            if(value != ""){
                                try{
                                    if(value.length > 0){
                                        var reboots = parseInt(value);
                                        if(reboots < 5){
                                            self.OS.writeFile(self.ROUTES['REBOOT'].path,(reboots+1),function(ok,file_ref,params){
                                                self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                                setTimeout(function(){
                                                    self.OS.rebootSystem(self.platform);
                                                }, 10000);
                                            });
                                        }
                                        else{
                                            var ob='<img  width="1920" height="1080" src="'+self.ROUTES['STYLE'].path+'"contactTechnicalSupport.jpg">';
                                            document.getElementById("emergency").innerHTML=ob;
                                        }
                                    }
                                    self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                        self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                        setTimeout(function(){
                                            self.OS.rebootSystem(self.platform);
                                        }, 10000);
                                    });
                                }catch(e){
                                    console.log(e);
                                    self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                        self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                        setTimeout(function(){
                                            self.OS.rebootSystem(self.platform);
                                        }, 10000);
                                    });
                                }
                            }
                            else{
                                self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                });
                            }
                        });
                    }
                }
            }
            //if(!self.timeChecked){
                if(isNaN(localDate)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+7,self.name+": Function serverDateTimeResponse() : localDate is NaN : "+localDate);
                    bad_date = true;
                }else if(localDate >= 2106345600){
                    localDate = 1856610740; // HARD SET Tue Oct 31 2028 14:12:20 GMT+0100 (CET)
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+14,self.name+": Function serverDateTimeResponse() : date is in a invalid Future .. HARD SET Tue Oct 31 2028 14:12:20  : "+localDate);
                }

                if(isNaN(serverDate)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+8,self.name+": Function serverDateTimeResponse() : localDate is NaN : "+serverDate);
                    bad_date = true;
                }

                if(isNaN(timezoneOffset)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+9,self.name+": Function serverDateTimeResponse() : timezoneOffset is NaN "+timezoneOffset);
                    bad_date = true;
                }

                if(isNaN(new_timestamp)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+10,self.name+": Function serverDateTimeResponse() : new_timestamp is NaN : "+new_timestamp);
                    bad_date = true;
                }

                if(isNaN(futureTimezoneChange)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+11,self.name+": Function serverDateTimeResponse() : futureTimezoneChange is NaN : "+futureTimezoneChange);
                    //bad_date = true;
                    futureTimezoneChange = 0;
                }

                if(isNaN(futureTimezoneChange)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+12,self.name+": Function serverDateTimeResponse() : futureTimezoneOffset is NaN : "+futureTimezoneOffset);
                    //bad_date = true;
                    futureTimezoneOffset = 0;
                }

                if(!bad_date){
                    self.OS.setSystemDateTime(new_timestamp,function(ok){
                        if(ok){
                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : Device Set Time Completed OK");
                            self.setServerTimeParams(localDate*1000,
                                             serverDate*1000,
                                             timezoneOffset*1000,
                                             futureTimezoneChange*1000,
                                             futureTimezoneOffset*1000);
                            //$(self).trigger("SystemTimeUpdate",[before,after]);


                            // THIS ONLY WORKS ON NONE SEPARATED TRANSFER !!!!! (will work on soc, android, ios, ... but not on nwjs for example ... )

                            if(self.setTimeCallback){
                                self.setTimeCallback(localDate*1000,
                                                     serverDate*1000,
                                                     timezoneOffset*1000,
                                                     futureTimezoneChange*1000,
                                                     futureTimezoneOffset*1000);
                            }

                        }else{
                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : Impossible to set time for device ... retry");
                        }
                    });
                }else{
                     self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : bad date - not using serverTime ... ");
                }
            //}
        }
    };



}
TransferService.prototype = new BasicService();
